<template>
  <div id="teacher_class_new_wrapper" class="bt-container">
    <!-- <div class="page-title">
      <template v-if="isEdit">{{ $t('TEACHER_CLASS.EDIT_COURSE') }}</template>
      <template v-else>{{ $t('TEACHER_CLASS.NEW_COURSE') }}</template>
      <a href="javascript:history.back();">
        <el-button size="small" style="float: right;">{{ $t('BOARD.BACK') }}</el-button>
      </a>
    </div> -->
    <div v-if="authType !== 4">
      <el-form
        :model="input"
        ref="elForm"
        label-position="left"
        label-width="190px"
        style="max-width: 800px;"
        class="elForm-label"
      >
        <!--<el-form-item label="상태" class="radio-item">
        <el-radio-group v-model.number="input.opened">
          <el-radio :label="0">공개</el-radio>
          <el-radio :label="1">비공개</el-radio>
          <el-radio :label="2">마감</el-radio>
        </el-radio-group>
        <el-popover
          style="position: relative; left: 30px; top: 3px;"
          placement="top-start"
          width="500"
          trigger="hover">
          <el-table :data="notice">
            <el-table-column width="100" property="title" label="상태"></el-table-column>
            <el-table-column width="400" property="content" label="내용"></el-table-column>
          </el-table>
          <i class="el-icon-question fa-lg" slot="reference"></i>
        </el-popover>
        </el-form-item>-->

        <el-form-item :label="$t('SUBJECT.CRT_TYPE')" v-if="!isEdit">
          <el-radio-group v-model="selCreateType" @change="selRadioChange">
            <el-radio label="1">{{ $t('SUBJECT.REQ_RES') }}</el-radio>
            <el-radio label="2">{{ $t('SUBJECT.SBJ_PW') }}</el-radio>
            <el-radio label="3">개방공간</el-radio>
          </el-radio-group>
        </el-form-item>

        <el-form-item :label="$t('SUBJECT.SBJ_PW')" v-if="selCreateType === '2'">
          <el-input v-model="input.class_password" class="subject-title"></el-input>
          <el-button @click="checkPassword(input.class_password)"> 유효성 체크 </el-button>
        </el-form-item>

        <el-form-item label="분야" v-if="selCreateType === '3'">
          <el-input v-if="isEdit" v-model="input.category" class="subject-title"></el-input>
          <div class="subject-category">
            <el-select
              v-model="input.openspace"
              placeholder="Select"
              @change="updateDropdwpns"
              style="width: 40%"
            >
              <el-option
                v-for="list in openspace"
                :key="list.name"
                :label="list.name"
                :value="list.name"
              ></el-option>
            </el-select>
            <el-select
              v-model="input.affiliationId"
              placeholder="Select"
              @change="updateDropdwpns"
              style="width: 59%; margin-left: -3px;"
            >
              <el-option
                v-for="list in openSpaceAffiliation"
                :key="list.affiliation_id"
                :label="list.description"
                :value="list.affiliation_id"
              ></el-option>
            </el-select>
          </div>
        </el-form-item>

        <el-form-item :label="$t('TEACHER_CLASS.COURSE_TITLE')">
          <el-input v-if="isEdit" v-model="input.title" class="subject-title"></el-input>
          <el-select
            v-else-if="!isEdit && selCreateType === '1'"
            v-model="input.title"
            class="subject-title"
            placeholder="Select"
            @change="updateDropdwpns"
          >
            <el-option
              v-for="title in acceptClass"
              :key="title.class_name"
              :label="title.class_name"
              :value="title.class_name"
            ></el-option>
          </el-select>
          <el-input v-else-if="!isEdit && selCreateType === '2'" v-model="input.title" readonly class="subject-title"></el-input>
          <el-input v-else-if="!isEdit && selCreateType === '3'" v-model="input.title" class="subject-title"></el-input>
        </el-form-item>
        <el-form-item :label="$t('TEACHER_CLASS.CLS_TYPE')">
          <el-input v-model="input.classType" class="subject-title" readonly></el-input>
        </el-form-item>

        <!-- 학정 번호 삭제
      <el-form-item :label="$t('TEACHER_CLASS.ACADEMIC_NUM')">
        <el-input v-model="input.num" class="subject-title"></el-input>
        </el-form-item>-->

        <!-- 과목 생성 비밀번호 삭제 20200505
      <el-form-item :label="$t('TEACHER_CLASS.CRS_PWD')">
        <template>
          <div>
            <el-input v-if="!isEdit" v-model="input.password" class="subject-title"></el-input>
            <el-input v-else v-model="input.password" class="subject-title" :disabled="true"></el-input>
          </div>
        </template>
      </el-form-item>
        -->
        <el-form-item :label="$t('TEACHER_CLASS.COURSE_SMR_INTRO')">
          <el-input type="textarea" :rows="3" v-model="input.summary" class="subject-summary"></el-input>
        </el-form-item>

        <el-form-item :label="$t('TEACHER_CLASS.LEC_DUR')">
          <el-date-picker v-model="input.activeStartDate" type="datetime" class="subject-startDate"></el-date-picker> ~ 
          <el-date-picker v-model="input.activeEndDate" type="datetime" class="subject-endDate"></el-date-picker>
        </el-form-item>

        <!--
      <el-form-item v-if="input.openCheck === 0" label="수강 신청 비밀번호">
        <template>
          <el-input v-model="input.enrollPassword" class="subject-title" :disabled="isEdit"></el-input>
        </template>
      </el-form-item>

      <el-form-item v-if="input.openCheck === 0" label="수강 신청 비밀번호 유효 기간">
        <el-date-picker
          v-model="input.passwordStartDate"
          type="datetime" class="subject-startDate"
          @change="checkPasswordDate"
        >
        </el-date-picker>
         ~
         <el-date-picker
          v-model="input.passwordEndDate"
          type="datetime" class="subject-endDate"
          @change="checkPasswordDate"
        >
        </el-date-picker>
      </el-form-item>

      <el-form-item v-if="input.openCheck === 0" label="수강 신청 비밀번호 사용 인원">
        <el-input-number v-model="input.maxNumber" controls-position="right" :min="1" :max="1000" :precision="0" class="lecture-number"></el-input-number>
        <el-button
          type="primary"
          @click="passwordPost"
          class="putLecture-btn">
          비밀번호 생성
        </el-button>
        </el-form-item>-->

        <!--
      <el-form-item label="정원">
        <el-input type="number" v-model.number="input.capacity" :disabled="input.capacityCheck" class="subject-capacity"></el-input>
      </el-form-item>

      <el-form-item label="정원 제한 없음">
        <el-switch v-model="input.capacityCheck"></el-switch>
      </el-form-item>

      <el-form-item label="강사 소개">
        <el-input type="textarea" :rows="3" v-model="input.lecturerDescription" class="teacher-description"></el-input>
      </el-form-item>

      <el-form-item label="과목 상세 소개">
        <el-input type="textarea" :rows="6" v-model="input.description" class="subject-description"></el-input>
        </el-form-item>-->

        <el-form-item v-if="selCreateType !== '3'" label="개방공간 공개여부">
          <el-switch v-model="input.isOpenSpaceCheck"
            active-text="공개"
            inactive-text="비공개"
          />
        </el-form-item>
        <el-form-item label="분야" v-if="input.isOpenSpaceCheck">
          <div class="subject-category">
            <el-select
              v-model="input.openspace"
              placeholder="Select"
              @change="updateDropdwpns"
              style="width: 40%"
            >
              <el-option
                v-for="list in openspace"
                :key="list.name"
                :label="list.name"
                :value="list.name"
              ></el-option>
            </el-select>
            <el-select
              v-model="input.affiliationId"
              placeholder="Select"
              @change="updateDropdwpns"
              style="width: 59%; margin-left: -3px;"
            >
              <el-option
                v-for="list in openSpaceAffiliation"
                :key="list.description"
                :label="list.description"
                :value="list.description"
              ></el-option>
            </el-select>
          </div>
        </el-form-item>

        <el-form-item>
          <!-- TODO: use button loading -->
          <el-button type="primary" @click="onSubmit" class="subject-btn">
            <template v-if="isEdit">{{ $t('TEACHER_CLASS.EDIT_COURSE') }}</template>
            <template v-else>{{ $t('TEACHER_CLASS.NEW_COURSE') }}</template>
          </el-button>
        </el-form-item>
      </el-form>
    </div>

    <div v-else>
      <el-form
        :model="input"
        ref="elForm"
        label-position="left"
        label-width="190px"
        style="max-width: 800px;"
        class="elForm-label"
      >
        <!-- <el-form-item :label="$t('TEACHER_CLASS.CRS_TYPE')">
          <el-radio v-model="selSubjectType" label="1">{{ $t('TEACHER_CLASS.SUBJ_TYPE_PRIVATE') }}</el-radio>
          <el-radio v-model="selSubjectType" label="2">{{ $t('TEACHER_CLASS.SUBJ_TYPE_PUBLIC') }}</el-radio>
        </el-form-item> -->

        <el-form-item :label="$t('TEACHER_CLASS.COURSE_TITLE')">
          <el-input v-model="input.title" class="subject-title"></el-input>
        </el-form-item>

        <el-form-item :label="$t('TEACHER_CLASS.CLS_TYPE')">    <!-- 주제 유형  -->
          <el-input v-if="isEdit" v-model="input.classType" class="subject-title" readonly></el-input>
          <el-select
            v-model="input.classType"
            class="subject-title"
            :placeholder="$t('TEACHER_CLASS.TYPE')"
            v-if="!isEdit">
            <el-option :label="$t('TEACHER_CLASS.TYPE_GENERAL')" value="1"></el-option>
            <!--<el-option v-if="selSubjectType === '1'" :label="$t('TEACHER_CLASS.TYPE_STREAMING')" value="2"></el-option>-->
            <el-option :label="$t('TEACHER_CLASS.TYPE_PRACTICE')" value="3"></el-option>
            <el-option :label="$t('TEACHER_CLASS.TYPE_ETC')" value="4"></el-option>
          </el-select>
        </el-form-item>

        <el-form-item :label="$t('TEACHER_CLASS.COURSE_SMR_INTRO')">  <!-- 주제  -->
          <el-input type="textarea" :rows="3" v-model="input.summary" class="subject-summary"></el-input>
        </el-form-item>

        <el-form-item :label="$t('TEACHER_CLASS.LEC_DUR')">
          <el-date-picker v-model="input.activeStartDate" type="datetime" class="subject-startDate"></el-date-picker>~
          <el-date-picker v-model="input.activeEndDate" type="datetime" class="subject-endDate"></el-date-picker>
        </el-form-item>

        <el-form-item>
          <!-- TODO: use button loading -->
          <el-button type="primary" @click="onSubmit" class="subject-btn">
            <!-- <template>{{ $t('TEACHER_CLASS.NEW_COURSE') }}</template> -->
            <template v-if="isEdit">{{ $t('TEACHER_CLASS.EDIT_COURSE') }}</template>
            <template v-else>{{ $t('TEACHER_CLASS.NEW_COURSE') }}</template>
          </el-button>
        </el-form-item>
      </el-form>
    </div>
  </div>
</template>

<script>
import classService from "../../services/classService";
import authService from "../../services/authService";
import utils from "../../utils";
import userService from '../../services/userService';
import createClass from '../../services/createClass';
import openspaceService from '../../services/openspaceService';
import { mapActions } from 'vuex';
import _ from 'lodash';

export default {
  name: "TeacherClassNew",
  async created() {
    const vm = this;
    // 학생이 url로 접근하는 경우 방지
    const accessId = utils.getUserIdFromJwt();
    const accessCheck = await authService.returnUserInfo({
      userID: accessId,
    });
    if (accessCheck.data.userInfo.type === 0) {
      vm.$router.push("/");
    }
    const creatingInfo = await classService.getCreatingInfo();

    /* 과목 비밀 번호 체크 삭제 20200505 (backend getCreatingInfo 부분 수정하시길 바랍니다.)
    creatingInfo.data.info.forEach((x) => {
      if (x.create_check === 0) {
        const tmp = {};
        tmp.password = x.password;
        vm.passwordCheck.push(tmp);
      }
    });*/

    // req_class_create에서 수락된 것만(type 1)인 것만 저장
    creatingInfo.data.acceptInfo.forEach(async (x) => {
      if (x.status === 1) {
        await vm.acceptClass.push(x);
      }
    });
    const res = await createClass.getClassPassword();
    res.data.list.forEach(async (x) => {
      await vm.passwordList.push(x);
    });

    // 개방 공간 맛보기 리스트 가져오기
    const res2 = await createClass.getOpenSpaceAffiliation();
    res2.data.result.forEach((element) => {
      vm.openSpaceAffiliation.push(element);
    });

    const res3 = await openspaceService.get2ndCategories();
    vm.openspace = res3.data;
  },
  props: {
    editCourseData: {
      type: Object,
      default: function () {
        return {};
      }
    }
  },
  data() {
    const initialInput = {
      title: "",
      classType: "",
      opened: 0,
      summary: "",
      activeStartDate: new Date(),
      activeEndDate: new Date(),
      capacity: 0, // 0은 무제한
      capacityCheck: false,
      // TODO: teacherImage는 따로 api를 뺴야할 듯? 나중에 ㄱㄱ
      lecturerDescription: "",
      description: "",
      belonging: "",
      num: "",
      password: "",
      openCheck: 1,
      enrollPassword: "",
      signUpStartDate: new Date(),
      signUpEndDate: new Date(Date.now() + 7 * 24 * 60 * 60 * 1000),
      passwordStartDate: new Date(),
      passwordEndDate: new Date(),
      maxNumber: 999,
      type: 0,
      reqId: "",
      class_password: '',
      affiliationId: '',
      openspace: '',
      isOpenSpaceCheck: false,
      isOpenSpace: undefined,
      
      // [주제 개설 요청]으로 강의를 생성 할 경우 affiliation_id가 undefined이기 떄문에
      // 실제 기관의 affiliation_id를 임시 변수에 넣어준다.
      tempAffiliationId: undefined,   
    };
    return {
      initialInput,
      input: Object.assign({}, initialInput), // 복사해서 넣음
      notice: [
        {
          title: this.$t("LECTURE.OPEN"),
          content: this.$t("HELP.EDIT_COURSE1"),
        },
        {
          title: this.$t("LECTURE.CLOSED"),
          content: this.$t("HELP.EDIT_COURSE2"),
        },
        {
          title: this.$t("TEACHER_CLASS.DEADLINE"),
          content: this.$t("HELP.EDIT_COURSE3"),
        },
      ],
      passwordCheck: [],
      belongings: [],
      classPassword: "",
      openCheck: [
        {
          value: 0,
          label: this.$t("LECTURE.CLOSED"),
        },
        {
          value: 1,
          label: this.$t("LECTURE.OPEN"),
        },
      ],
      acceptClass: [],
      selSubjectType: '1',
      selCreateType: '1',
      passwordList: [],
      openSpaceAffiliation: [],
      openspace: [],
    };
  },
  async mounted() {
    const vm = this;
    if (vm.isEdit) {
      const res = await classService.getClass({ id: vm.classId });
      // const res2 = await classService.getClassEnrollPasswordById({ id: vm.classId });
      vm.input.title = res.data.name || vm.initialInput.title;
      // vm.input.opened = res.data.opened || vm.initialInput.opened;
      vm.input.summary = res.data.summary || vm.initialInput.summary;
      vm.input.activeStartDate = res.data.start_time;
      vm.input.activeEndDate = res.data.end_time;
      // vm.input.capacity = res.data.capacity || vm.initialInput.capacity; // 정원 0은 무제한
      // vm.input.capacityCheck = vm.input.capacity === 0;
      // vm.input.lecturerDescription = res.data.lecturer_description;
      // vm.input.description = res.data.description;
      vm.input.openCheck = res.data.view_type || vm.initialInput.openCheck;
      vm.input.signUpStartDate = res.data.sign_up_start_time;
      vm.input.signUpEndDate = res.data.sign_up_end_time;
      // vm.input.password = (res.data.class_password === null ? null : res.data.class_password.password) || vm.initialInput.password;
      // vm.input.num = res.data.num || vm.initialInput.num;
      // vm.input.enrollPassword = res2.data.data === undefined ? vm.initialInput.enrollPassword : res2.data.data.password;
      // vm.input.passwordStartDate = res2.data.data === undefined ? vm.initialInput.passwordStartDate : res2.data.data.start_time;
      // vm.input.passwordEndDate = res2.data.data === undefined ? vm.initialInput.passwordEndDate : res2.data.data.end_time;
      // vm.input.maxNumber = res2.data.data === undefined ? vm.initialInput.maxNumber : res2.data.data.max;
      if (res.data.type === 1) {
        vm.input.classType = "일반";
      } else if (res.data.type === 2) {
        vm.input.classType = "실시간 스트리밍";
      } else if (res.data.type === 3) {
        vm.input.classType = "실습";
      } else if (res.data.type === 4) {
        vm.input.classType = "시연";
      }
      if (!res.data.isOpenSpace) {
        vm.input.isOpenSpaceCheck = false;
      } else {
        vm.input.isOpenSpaceCheck = true;
        const tmp = res.data.isOpenSpace.split('/');
        vm.input.openspace = tmp[0];
        vm.input.affiliationId = tmp[1];
      }
    }
  },
  computed: {
    isEdit() {
      const vm = this;
      return vm.$route.fullPath.includes("/edit") || !_.isEmpty(vm.editCourseData);
    },
    classId() {
      const vm = this;

      return !_.isEmpty(vm.editCourseData) ? vm.editCourseData.class_id : vm.$route.path.split("class/")[1].split("/edit")[0];
    },
    authType() {
      const vm = this;
      const jwt = vm.$store.state.auth.jwt;
      return utils.getAuthTypeFromJwt(jwt);
    },
  },
  methods: {
    ...mapActions('class', [
      'getMyClassLists',
    ]),
    updateDropdwpns() {
      const vm = this;
      vm.acceptClass.forEach((x) => {
        if (vm.input.title === x.class_name) {          
          if (x.type === 1) {
            vm.input.classType = "일반";
            vm.input.type = 1;
            vm.input.reqId = x.req_id;
          } else if (x.type === 2) {
            vm.input.classType = "실시간 스트리밍";
            vm.input.type = 2;
            vm.input.reqId = x.req_id;
          } else if (x.type === 3) {
            vm.input.classType = "실습";
            vm.input.type = 3;
            vm.input.reqId = x.req_id;
          } else if (x.type === 4) {
            vm.input.classType = "시연";
            vm.input.type = 4;
            vm.input.reqId = x.req_id;
          }
          // [주제 개설 요청]으로 강의를 생성 할 경우 affiliation_id가 undefined이기 떄문에
          // 실제 기관의 affiliation_id를 임시 변수에 넣어준다.
          vm.input.tempAffiliationId = x.affiliation_id;
        }
      });
    },
    checkPassword(pw) {
      const vm = this;
      vm.input.title = '';
      vm.input.classType = '';
      vm.input.type = 0;
      let flag = false;

      vm.passwordList.forEach((x) => {
        if (x.password === pw) {
          flag = true;
          vm.input.title = x.req_create_class.class_name;
          if (x.req_create_class.type === 1) {
            vm.input.classType = "일반";
            vm.input.type = 1;
          } else if (x.req_create_class.type=== 2) {
            vm.input.classType = "실시간 스트리밍";
            vm.input.type = 2;
          } else if (x.req_create_class.type === 3) {
            vm.input.classType = "실습";
            vm.input.type = 3;
          } else if (x.req_create_class.type === 4) {
            vm.input.classType = "시연";
            vm.input.type = 4;
          }
          vm.input.reqId = x.req_create_class.req_id;
        }
      });
      if (!flag) {
        vm.$notify({
          title: vm.$t("NOTIFY.ERROR"),
          message: "일치하는 주제 비밀번호가 없습니다.",
          type: "error",
        });
        vm.input.title = '';
        vm.input.classType = '';
        vm.input.type = 0;
      }
    },
    onSubmit() {
      // TODO. 2021-05-12 개방공간으로 등록되었을 때 알림 등록
      const vm = this;
      // 과목 제목 입력 안했을 경우 오류 처리 - 190211
      if (vm.input.title === "") {
        vm.$notify({
          title: vm.$t("NOTIFY.ERROR"),
          message: vm.$t("NOTIFY.ENTER_SUBJ_NAME"),
          type: "error",
        });
        return;
      }
      // 과목 시작 시간이 끝 시간보다 빠르면 오류 처리 - 190211
      if (vm.input.activeStartDate > vm.input.activeEndDate) {
        vm.$notify({
          title: vm.$t("NOTIFY.ERROR"),
          message: vm.$t("NOTIFY.LATER_STRT_END"),
          type: "error",
        });
        return;
      }
      // 과목 생성 비밀번호 체크
      /*
      if (vm.input.password === '' && !vm.isEdit) {
        vm.$notify({
          title: vm.$t('NOTIFY.ERROR'),
          message: vm.$t('NOTIFY.MAX_NUM_THOUS'),
          type: 'error',
        });
        return;
      } else if (!vm.isEdit){
        let checkFlag = false;
        vm.passwordCheck.forEach((x) => {
          if (x.password === vm.input.password) {
            checkFlag = true;
          }
        });
        if (checkFlag === false) {
          vm.$notify({
            title: vm.$t('NOTIFY.ERROR'),
            message: vm.$t('NOTIFY.PWD_SUBJ_NOT_EXIST'),
            type: 'error',
          });
          return;
        }
      }
      */
      // 수강 신청 시작 시간이 끝 시간보다 빠르면 오류 처리
      if (vm.input.signUpStartDate > vm.input.signUpEndDate) {
        vm.$notify({
          title: vm.$t("NOTIFY.ERROR"),
          message: vm.$t("NOTIFY.LATE_START_DATE"),
          type: "error",
        });
        return;
      }
      /*
      // 최대 수강 정원은 10000명. 10000명을 넘어설 경우 미리 차단
      if (vm.input.capacity > 10000) {
        vm.$notify({
          title: '오류',
          message: '최대 수강 정원은 10000명입니다. 그 이상을 원하시면 무제한으로 설정해주세요.',
          type: 'warning',
        });
        return;
      } */
      vm.$refs.elForm.validate(async (/* valid, fields */) => {
        // TODO: if valid === true 로 감싸기
        // TODO: valid === false인 경우에 notify
        if (vm.isEdit) {
          const id = vm.classId;
          // TODO: wrap with try catch
          try {
            if (vm.input.isOpenSpaceCheck) {
              vm.input.isOpenSpace = vm.input.openspace + '/' + vm.input.affiliationId;
            }
            await classService.NNputClass({
              id,
              ...vm.input,
            });

            if (_.isEmpty(vm.editCourseData)) {
              vm.$router.go(-1);
            } else {
              vm.$listeners['finish']();
            }
          } catch (error) {
            vm.$notify({
              title: vm.$t("NOTIFY.FAIL_EDIT_SUBJ"),
              message: error.toString(),
              type: "error",
              duration: 0,
            });
          }
        } else {
          // TODO: wrap with try catch
          try {
            if (vm.authType === 4) {
              // 기관 관리자 강의 개설
              const res = await userService.getUserBelongings();
              const res2 = await createClass.requestClass({
                subjectType: vm.selSubjectType,
                affiliationId: res.data.response[0].affiliation_id,
                class_type: vm.input.classType,
                className: vm.input.title,
                class_detail: vm.input.summary,
                isOpenSpace: vm.input.openspace + '/' + vm.input.affiliationId,
              });
              vm.input.reqId = res2.data.result.req_id;
              
              if (Number(vm.input.classType) !== 4) {
                await classService.NNpostClass(vm.input);
              }

            } else {
              // 일반 사용자가 강의 개설
              if (vm.selCreateType === '2') {
                const res = await createClass.getClassPasswordByPassword({
                  pwd: vm.input.class_password,
                });
                vm.input.isOpenSpace = vm.input.openspace + '/' + vm.input.affiliationId;                
                
                // [주제 개설 요청]으로 강의를 생성 할 경우 affiliation_id가 undefined이기 떄문에
                // 실제 기관의 affiliation_id를 임시 변수에 넣어준다.
                vm.input.affiliationId = vm.input.tempAffiliationId;                
              } else if (vm.selCreateType === '3') {    // 3: 개방공간
                // 여러가지 일 추가
                const res = await createClass.requestClass({
                  subjectType: 1,   //1: 강의, 시연   3: 실습
                  affiliationId: vm.input.affiliationId,
                  class_type: vm.input.type,
                  className: vm.input.title,
                  class_detail: vm.input.summary,
                  id_2nd: vm.input.openspace,
                  isOpenSpace: vm.input.openspace + '/' + vm.input.affiliationId,
                });
                vm.input.reqId = res.data.result.req_id;
              } else if (vm.selCreateType === '1') {
                vm.input.isOpenSpace = vm.input.openspace + '/' + vm.input.affiliationId;                                
              }
              await classService.NNpostClass(vm.input);
            }
            vm.$listeners['finish']();
          } catch (error) {
            vm.$notify({
              title: vm.$t("NOTIFY.FAIL_CRE_SUBJ"),
              message: error.toString(),
              type: "error",
              duration: 0,
            });
          }
        }
      });
    },
    selRadioChange() {
      const vm = this;

      vm.input.classType = '';
      vm.input.type = 0;
      vm.input.title = '';
      vm.input.class_password = '';
      vm.input.summary = '';

      if (vm.selCreateType === '3') {
        vm.input.classType = '시연';
        vm.input.type = 4;
      }
    }
  },
  watch: {
    // NOTE: 이거 () => {}로 바꾸면 안됨!! vm이 다른 녀석 들어옴
    "input.capacityCheck": function handler(newVal) {
      const vm = this;
      if (newVal) {
        vm.input.capacity = 0;
      }
    },
  },
};
</script>

<style lang="scss" scoped>
#teacher_class_new_wrapper {
  .lecture-number {
    width: 165px;
  }

  .page-title {
    float: left;
    width: 100%;
    height: 24px;
    font-family: SpoqaHanSans;
    font-size: 25px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1.2;
    letter-spacing: normal;
    color: #000000;
    margin-top: 40px;
    margin-left: 7px;
    margin-bottom: 30px;
  }
  .el-form-item__label {
    font-size: 30px;
  }
  .elForm-label el-form-item {
    text-align: left;
    font-family: SpoqaHanSans;
    font-size: 16px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 40px;
    letter-spacing: normal;
    color: #000000;
  }
  .subject-title {
    width: 450px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-category {
    width: 450px;
    height: 40px;
    border-radius: 4px;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-summary {
    width: 450px;
    height: 100%;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-startDate {
    width: 210px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #d8dce6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-endDate {
    width: 210px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #d8dce6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-capacity {
    width: 450px;
    height: 40px;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .teacher-description {
    width: 450px;
    height: 100%;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-description {
    width: 450px;
    height: 100%;
    border-radius: 4px;
    background-color: #ffffff;
    border: solid 1px #dcdfe6;
    font-family: AppleSDGothicNeo;
    font-size: 14px;
    font-weight: normal;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    color: #909399;
  }
  .subject-btn {
    width: 450px;
    height: 40px;
    border-radius: 3px;
    background-color: #1989fa;
    font-family: SpoqaHanSans;
    font-size: 12px;
    font-weight: bold;
    font-style: normal;
    font-stretch: normal;
    line-height: 1;
    letter-spacing: normal;
    text-align: center;
    color: #ffffff;
  }
}
</style>
